package ANEP;

/*
 * $Id: ANONAddress.java,v 1.1 1997/11/21 21:38:01 mwh Exp $
 * $Revision: 1.1 $
 *
 * Copyright 1997 by Carl A. Gunter, Mike Hicks, Pankaj Kakkar,
 * Jonathan Moore, Scott Nettles
 *
 */

import java.net.*;

public class ANONAddress {

  private byte[] addr;
  private InetAddress inetAddr;
  private int port;


  public ANONAddress(byte[] addr) {
    if (addr.length != 16)
      throw new Error("bad ANON addr");
    this.addr = addr;
    inetAddr = null;
    port = -1;
  }

  public ANONAddress(InetAddress inetAddr, int port) {

    MD5 md5 = new MD5();
    this.inetAddr = inetAddr;
    byte [] ipAddr = inetAddr.getAddress ();
    this.port = port;

    byte[] buf = new byte[6];
    buf [0] = ipAddr[0];
    buf [1] = ipAddr[1];
    buf [2] = ipAddr[2];
    buf [3] = ipAddr[3];   
    buf [4] = (byte)((port >> 8) & 0xff);
    buf [5] = (byte)(port & 0xff);    

    // System.out.println("in to MD5:");
    // for (int i=0; i<6; i++) 
	// System.out.print("["+buf[i]+"]");
    // System.out.println("\n");
    this.addr = md5.hash(buf);
  }

  public InetAddress getInetAddr() { return inetAddr; }
  public int getPort() { return port; }
  public byte[] getAddr() { return addr; }

  public static void main(String args[]) throws Exception {
    ANONAddress addr;
    addr = new ANONAddress(InetAddress.getByName(args[0]),
			   Integer.parseInt(args[1]));
    System.out.println("AA:");
    byte[] aa = addr.getAddr();
    for (int i=0; i<16; i++) 
	System.out.print("["+aa[i]+"]");
    System.out.println("\n");
  }
}
/*
 * $Log: ANONAddress.java,v $
 * Revision 1.1  1997/11/21 21:38:01  mwh
 * Initial revision
 *
 *
 */
