package ANEP;

/*
 * $Id: ANONLeafPacket.java,v 1.1 1997/11/21 21:38:01 mwh Exp $
 * $Revision: 1.1 $
 *
 * Copyright 1997 by Carl A. Gunter, Mike Hicks, Pankaj Kakkar,
 * Jonathan Moore, Scott Nettles
 *
 */

import java.io.*;
import java.net.InetAddress;

public class ANONLeafPacket extends ANEPacket {

  public final static int HUB_ID = 0;

  /*
   *  Constructors
   */

  public ANONLeafPacket (SchemeAddrIPv4Port source,
			 int ANEPTypeId,
			 InetAddress[] leaves,
			 int[] leafports) 
       throws ANONLeafPacketException {

    setDefaults();
    this.typeId = ANONrouteTypeId;
    this.TLVs = TLVList.Cons(new AddrTLV(AddrTLV.SOURCE, source),
			     TLVList.Nil);
    // set the list of leaves to represent
    int numLeaves = leaves.length;
    if (numLeaves != leafports.length)
      throw new ANONLeafPacketException("size of leaves[] not the same as "+
					"leafports[]");
    ANONAddress aa;

    payload = new byte[numLeaves * 16 + 4];
    payload[0] = 0; 
    payload[1] = 1;
    payload[2] = (byte)((ANEPTypeId >> 8) & 0xff);
    payload[3] = (byte)(ANEPTypeId & 0xff);    

    for (int i = 0; i<numLeaves; i++) {
      aa = new ANONAddress(leaves[i],leafports[i]);
      System.arraycopy(aa.getAddr(),0,payload,i*16+4,16);
//      byte[] addr = aa.getAddr();
//      System.out.println("adding address "+leaves[i]+":"+leafport[i]);
//      for (int j = 0; j<16; j++)
//        System.out.print("["+addr[j]+"]");
//      System.out.println("");
    }

    setLengths();
  }
}
/*
 * $Log: ANONLeafPacket.java,v $
 * Revision 1.1  1997/11/21 21:38:01  mwh
 * Initial revision
 *
 *
 */
