package ANEP;

/*
 * $Id: AddrTLV.java,v 1.1 1997/11/21 21:38:01 mwh Exp $
 * $Revision: 1.1 $
 *
 * Copyright 1997 by Carl A. Gunter, Mike Hicks, Pankaj Kakkar,
 * Jonathan Moore, Scott Nettles
 *
 */

import java.io.IOException;

public class AddrTLV extends TLV {
  
  final static public short SOURCE = 1;
  final static public short DESTINATION = 2;

  private SchemeAddr addr;

  public AddrTLV (int type, SchemeAddr addr) {
    super ();
    
    // subclass specific data
    this.addr = addr;

    // type (should be one of SOURCE or DESTINATION)
    this.type = type;

    // value
    this.value = addr.marshall(); // assumes this is word-aligned
    length = 1 + (value.length / 4); // includes the option header
  }

  public SchemeAddr getSchemeAddr () { return addr; }
  
  public String toString () {
    return "Address option : " + type + " " + addr;
  }
}
/*
 * $Log: AddrTLV.java,v $
 * Revision 1.1  1997/11/21 21:38:01  mwh
 * Initial revision
 *
 *
 */
