package ANEP;
import java.io.*;

public abstract class SchemeAddr {

  public final static int IPv4 = 1;
  public final static int IPv4UDP = 5;
  public final static int IPv4TCP = 6;

  protected int schemeType;

  public abstract byte[] marshall();
  public abstract void marshall(byte[] value, int offset);

  public static SchemeAddr unmarshall(byte[] value) 
       throws IOException {

    // get scheme type
    ByteArrayInputStream is = new ByteArrayInputStream(value);
    int schemeType = Marshalling.getInt(is);

    switch (schemeType) {
    case IPv4:
      return SchemeAddrIPv4.unmarshall(value);
    case IPv4UDP:
    case IPv4TCP:
      return SchemeAddrIPv4Port.unmarshall(value);
    default:
      throw new IOException("Unknown SchemeAddr scheme type "+schemeType);
    }
  }

  public int getSchemeType() { return schemeType; }
  public abstract String toString();
}
/*
 * $Log: SchemeAddr.java,v $
 * Revision 1.1  1997/11/21 21:38:01  mwh
 * Initial revision
 *
 *
 */
