package ANEP;

/*
 * $Id: TLV.java,v 1.3 1997/11/21 21:38:01 mwh Exp $
 * $Revision: 1.3 $
 *
 * Copyright 1997 by Carl A. Gunter, Mike Hicks, Pankaj Kakkar,
 * Jonathan Moore, Scott Nettles
 *
 */

import java.io.*;

public class TLV {
  protected int type;
  protected int length;
  protected byte [] value;
  
  public TLV () {
    type = 0; length = 0; value = null;
  }
  
  public TLV (int type, int length, byte [] value) {
    this.type = type;
    this.length = length;
    this.value = value;
  }
  
  public TLV (TLV t) {
    this.type = t.type;
    this.length = t.length;
    this.value = t.value;
  }
  
  public int getType () { return type; }
  public int getLength () { return length; }
  public byte [] getValue () { return value; }
  
  public void marshall (OutputStream os) throws IOException {
    Marshalling.putAsShort (os, type);
    Marshalling.putAsShort (os, length);
    
    for (int i=0; i<(length-1)*4; i++)
      Marshalling.putByte (os, value [i]);
  }
  
  public static TLV unmarshall (InputStream is) throws IOException {
    byte [] value;
    short i;
    
    int type = Marshalling.getAsShort (is);
    int length = Marshalling.getAsShort (is);
    
    value = new byte [(length-1)*4];
    for (i=0; i<(length-1)*4; i++)
      value [i] = Marshalling.getByte (is);

    switch (type) {
    case AddrTLV.SOURCE:
    case AddrTLV.DESTINATION:
      SchemeAddr addr = SchemeAddr.unmarshall(value);
      return new AddrTLV(type,addr);
    default:
      return new TLV(type,length,value);
    }
  }
  
  public String toString () {
    String valStr = "";
    
    for (int i=0; i<(length-1)*4; i++)
      valStr = valStr + value[i] + " ";
    
    return
      ("Type = " + type +
       ";\tLength = " + length +
       ";\tValue = " + valStr);
  }
}
/*
 * $Log: TLV.java,v $
 * Revision 1.3  1997/11/21 21:38:01  mwh
 * Fixed marshalling to respect network byte order.  Added additional
 * classes to support ANON.
 *
 *
 */
