package ANEP;

/*
 * $Id: TLVList.java,v 1.4 1997/11/21 21:38:01 mwh Exp $
 * $Revision: 1.4 $
 *
 * Copyright 1997 by Carl A. Gunter, Mike Hicks, Pankaj Kakkar,
 * Jonathan Moore, Scott Nettles
 *
 */

abstract public class TLVList {

  abstract public TLV head ();
  abstract public TLVList tail ();
  
  public static TLVList Cons (TLV t, TLVList tl) { return new TLVCell (t, tl); }
  public static TLVList Nil = new TLVNil();

  abstract public int length ();
  abstract public TLV find (int type) throws TLVNotFoundException;

  abstract public String toString();
}

class TLVCell extends TLVList {
  private TLV head;
  private TLVList tail;

  public TLVCell (TLV t, TLVList tl) { head = t; tail = tl; }

  public TLV head () { return head; }
  public TLVList tail () { return tail; }

  public int length () {
    if (tail instanceof TLVNil)
      return head.getLength ();
    else return head.getLength () + tail.length ();
  }
  
  public TLV find (int type) throws TLVNotFoundException {
    if (head.getType () == type)
      return head;
    else if (tail instanceof TLVNil)
      throw new TLVNotFoundException ();
    else return tail.find (type);
  }

  public String toString() {
    if (tail instanceof TLVNil)
      return head.toString();
    else
      return (head.toString() + ";\n" + tail.toString());
  }
}

class TLVNil extends TLVList {
  public TLV head () { throw new Error("Hd"); }
  public TLVList tail () { throw new Error("Tl"); }

  public int length() {
    return 0;
  }
  public TLV find (int type) throws TLVNotFoundException {
    throw new TLVNotFoundException ();
  }

  public String toString() {
    return "Empty";
  }
}
/*
 * $Log: TLVList.java,v $
 * Revision 1.4  1997/11/21 21:38:01  mwh
 * Fixed marshalling to respect network byte order.  Added additional
 * classes to support ANON.
 *
 *
 */
